//Debugging helpers
//written by Luke Lenhart, 2007
//See /docs/License.txt for details on how this code may be used.

#include "../Debug.h"
#include <execinfo.h>

namespace MPMA
{
	//returns a string representing the call stack (with source locations) for the current thread
#ifdef DEBUG_CALLSTACK_ENABLED
	std::string GetCallStack()
	{
		//do the trace
		void *traceList[100];
		int listCount=backtrace(traceList, 100);
		if (listCount==0) return std::string();
		
		//do symbol lookups and store in a nice string
		std::string str;
		char **strBuff=backtrace_symbols(traceList, listCount);
		for (int i=1; i<listCount; ++i)
		{
			str+=strBuff[i];
			str+="\n";
		}
		
		free(strBuff);
		return str;
	}
#endif
}
