//tests some thread basics work
//Luke Lenhart, 2007
//See /docs/License.txt for details on how this code may be used.

#include "../UnitTest.h"
#include "base/Thread.h"
using namespace MPMA;

#ifdef DECLARE_TESTS_CODE
class ThreadBasic: public UnitTest
{
public:
	bool Run()
	{
		bool passed=true;
		
		//test that we can get a thread going at all
		volatile int testInt;
		{
			std::cout<<"Starting a thread... "<<std::endl;
			testInt=0;
			Thread greatThread(UberThread, ThreadParam((void*)&testInt));
			Sleep(100);
			if (testInt==0)
			{
				std::cout<<"It seems the thread never got going.\n";
				return false;
			}
			
			//will block terminate on destruction here
			std::cout<<"Testing termination..."<<std::endl;
		}
		int compareInt=testInt;
		Sleep(100);
		if (testInt!=compareInt)
		{
			std::cout<<"It seems to have not stopped."<<std::endl;
			passed=false;
		}
		
		//test deffered start
		//TODO: soon
		
		//test thread priorities
		//TODO: soon

		//
		return passed;
	}
	
	//not-so-intelligent thread that just repeatedly increments an integer
	static void UberThread(Thread &me, ThreadParam param)
	{
		volatile int &theirInt=*(int*)param.ptr;
		
		while (!me.IsEnding())
		{
			++theirInt;
			Sleep(5);
		}
	}
};
#endif
DECLARE_TEST_CASE(ThreadBasic)
